| The Gaudi Framework v27r1

- Main Page
- Related Pages
- Modules
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Types | Public Member Functions | Protected Member Functions | Protected Attributes | List of all members
Gaudi::Generic3D< INTERFACE, IMPLEMENTATION > Class Template Reference

Common AIDA implementation stuff for histograms and profiles using ROOT implementations. More...

`#include <GaudiPI/Generic3D.h>`

Inheritance diagram for Gaudi::Generic3D< INTERFACE, IMPLEMENTATION >:
[legend]
Collaboration diagram for Gaudi::Generic3D< INTERFACE, IMPLEMENTATION >:
[legend]

## Public Types
typedef Generic3D< INTERFACE, IMPLEMENTATION > | Base

## Public Member Functions
| Generic3D ()=default
| Default constructor. More...
| ~Generic3D () override=default
| Destructor. More...
TObject * | representation () const override
| ROOT object implementation. More...
void | adoptRepresentation (TObject *rep) override
| Adopt ROOT histogram representation. More...
int | dimension () const override
| Get the Histogram's dimension. More...
std::string | title () const override
| Get the title of the object. More...
bool | setTitle (const std::string &title) override
| Set the title of the object. More...
std::string | name () const
| object name More...
bool | setName (const std::string &newName)
| Sets the name of the object. More...
AIDA::IAnnotation & | annotation () override
| Access annotation object. More...
const AIDA::IAnnotation & | annotation () const override
| Access annotation object (cons) More...
int | entries () const override
| Get the number or all the entries. More...
int | allEntries () const override
| Get the number or all the entries, both in range and underflow/overflow bins of the IProfile. More...
double | sumBinHeights () const override
| Get the sum of in range bin heights in the IProfile. More...
double | sumAllBinHeights () const override
| Get the sum of all the bins heights (including underflow and overflow bin). More...
double | sumExtraBinHeights () const override
| Get the sum of the underflow and overflow bin height. More...
double | minBinHeight () const override
| Get the minimum height of the in-range bins. More...
double | maxBinHeight () const override
| Get the maximum height of the in-range bins. More...
int | rIndexX (int index) const
int | rIndexY (int index) const
int | rIndexZ (int index) const
double | binMeanX (int indexX, int, int) const override
| The weighted mean along the x axis of a given bin. More...
double | binMeanY (int, int indexY, int) const override
| The weighted mean along the y axis of a given bin. More...
double | binMeanZ (int, int, int indexZ) const override
| The weighted mean along the z axis of a given bin. More...
int | binEntries (int indexX, int indexY, int indexZ) const override
| Number of entries in the corresponding bin (ie the number of times fill was calle d for this bin). More...
int | binEntriesX (int index) const override
| Sum of all the entries of the bins along a given x bin. More...
int | binEntriesY (int index) const override
| Sum of all the entries of the bins along a given y bin. More...
int | binEntriesZ (int index) const override
| Sum of all the entries of the bins along a given z bin. More...
double | binHeight (int indexX, int indexY, int indexZ) const
| Total height of the corresponding bin (ie the sum of the weights in this bin). More...
double | binHeightX (int index) const override
| Sum of all the heights of the bins along a given x bin. More...
double | binHeightY (int index) const override
| Sum of all the heights of the bins along a given y bin. More...
double | binHeightZ (int index) const override
| Sum of all the heights of the bins along a given z bin. More...
double | binError (int indexX, int indexY, int indexZ) const override
| The error of a given bin. More...
double | meanX () const override
| The mean of the IHistogram3D along the x axis. More...
double | meanY () const override
| The mean of the IHistogram3D along the y axis. More...
double | meanZ () const override
| The mean of the IHistogram3D along the z axis. More...
double | rmsX () const override
| The RMS of the IHistogram3D along the x axis. More...
double | rmsY () const override
| The RMS of the IHistogram3D along the y axis. More...
double | rmsZ () const override
| The RMS of the IHistogram3D along the z axis. More...
const AIDA::IAxis & | xAxis () const override
| Get the x axis of the IHistogram3D. More...
const AIDA::IAxis & | yAxis () const override
| Get the y axis of the IHistogram3D. More...
const AIDA::IAxis & | zAxis () const override
| Get the z axis of the IHistogram3D. More...
int | coordToIndexX (double coord) const override
| Get the bin number corresponding to a given coordinate along the x axis. More...
int | coordToIndexY (double coord) const override
| Get the bin number corresponding to a given coordinate along the y axis. More...
int | coordToIndexZ (double coord) const override
| Get the bin number corresponding to a given coordinate along the z axis. More...
double | equivalentBinEntries () const override
| Number of equivalent entries, i.e. `SUM[ weight ] ^ 2 / SUM[ weight^2 ]` More...
bool | scale (double scaleFactor) override
| Scale the weights and the errors of all the IHistogram's bins (in-range and out-of-range ones) by a given scale factor. More...
bool | add (const INTERFACE &hist) override
| Add to this Histogram3D the contents of another IHistogram3D. More...
int | extraEntries () const override
std::ostream & | print (std::ostream &s) const override
| Print (ASCII) the histogram into the output stream. More...
std::ostream & | write (std::ostream &s) const override
| Write (ASCII) the histogram table into the output stream. More...
int | write (const char *file_name) const override
| Write (ASCII) the histogram table into a file. More...
template<>
void | adoptRepresentation (TObject *rep)
| Adopt ROOT histogram representation. More...
Public Member Functions inherited from Gaudi::HistogramBase
virtual | ~HistogramBase ()=default

## Protected Member Functions
| Generic3D (IMPLEMENTATION *p)
| constructor More...

## Protected Attributes
Gaudi::Axis | m_xAxis
Gaudi::Axis | m_yAxis
Gaudi::Axis | m_zAxis
AIDA::Annotation | m_annotation
| Object annotations. More...
std::unique_ptr< IMPLEMENTATION > | m_rep
| Reference to underlying implementation. More...
std::string | m_classType
int | m_sumEntries = 0

## Detailed Description

### template<typename INTERFACE, typename IMPLEMENTATION>
class Gaudi::Generic3D< INTERFACE, IMPLEMENTATION >

Common AIDA implementation stuff for histograms and profiles using ROOT implementations.

Credits: This code is the result of some stripdown implementation of LCG/PI. Credits to them!

Author
  M.Frank

Definition at line 34 of file Generic3D.h.

## Member Typedef Documentation

template<typename INTERFACE, typename IMPLEMENTATION>

typedef Generic3D<INTERFACE,IMPLEMENTATION> Gaudi::Generic3D< INTERFACE, IMPLEMENTATION >::Base

Definition at line 36 of file Generic3D.h.

## Constructor & Destructor Documentation

template<typename INTERFACE, typename IMPLEMENTATION>

Gaudi::Generic3D< INTERFACE, IMPLEMENTATION >::Generic3D | ( |  | ) |
| default

Default constructor.

template<typename INTERFACE, typename IMPLEMENTATION>

Gaudi::Generic3D< INTERFACE, IMPLEMENTATION >::Generic3D | ( | IMPLEMENTATION * | p | ) |
| inline protected

constructor

Definition at line 41 of file Generic3D.h.

41 : m_rep(p) { }
Gaudi::Generic3D::m_rep
std::unique_ptr< IMPLEMENTATION > m_rep
Reference to underlying implementation.
Definition: Generic3D.h:220
template<typename INTERFACE, typename IMPLEMENTATION>

Gaudi::Generic3D< INTERFACE, IMPLEMENTATION >::~Generic3D | ( |  | ) |
| override default

Destructor.

## Member Function Documentation

template<typename INTERFACE, typename IMPLEMENTATION>

bool Gaudi::Generic3D< INTERFACE, IMPLEMENTATION >::add | ( | const INTERFACE & | hist | ) |
| inline override

Add to this Histogram3D the contents of another IHistogram3D.

Definition at line 188 of file Generic3D.h.

188 {
189 const Base* p = dynamic_cast<const Base*>(&hist);
190 if ( !p ) throw std::runtime_error("Cannot add profile histograms of different implementations.");
191 m_rep->Add(p->m_rep.get());
192 return true;
193 }
std::runtime_error
STL class.
Gaudi::Generic3D::Base
Generic3D< INTERFACE, IMPLEMENTATION > Base
Definition: Generic3D.h:36
Gaudi::Generic3D::m_rep
std::unique_ptr< IMPLEMENTATION > m_rep
Reference to underlying implementation.
Definition: Generic3D.h:220
template<typename INTERFACE, typename IMPLEMENTATION>

void Gaudi::Generic3D< INTERFACE, IMPLEMENTATION >::adoptRepresentation | ( | TObject * | rep | ) |
| override virtual

Adopt ROOT histogram representation.

Implements Gaudi::HistogramBase.

template<>

void Gaudi::Generic3D< AIDA::IHistogram3D, TH3D >::adoptRepresentation | ( | TObject * | rep | ) |
| virtual

Adopt ROOT histogram representation.

Implements Gaudi::HistogramBase.

Definition at line 61 of file H3D.cpp.

61 {
62 TH3D* imp = dynamic_cast<TH3D*>(rep);
63 if ( !imp ) throw std::runtime_error("Cannot adopt native histogram representation.");
64 m_rep.reset( imp );
65 m_xAxis.initialize(m_rep->GetXaxis(),true);
66 m_yAxis.initialize(m_rep->GetYaxis(),true);
67 m_zAxis.initialize(m_rep->GetZaxis(),true);
68 const TArrayD* a = m_rep->GetSumw2();
69 if ( !a || (a && a->GetSize()==0) ) m_rep->Sumw2();
70 setTitle(m_rep->GetTitle());
71 }
Gaudi::Generic3D::m_xAxis
Gaudi::Axis m_xAxis
Definition: Generic3D.h:214
Gaudi::Generic3D::m_yAxis
Gaudi::Axis m_yAxis
Definition: Generic3D.h:215
std::runtime_error
STL class.
std::unique_ptr::reset
T reset(T...args)
Gaudi::Generic3D::m_zAxis
Gaudi::Axis m_zAxis
Definition: Generic3D.h:216
Gaudi::Generic3D::setTitle
bool setTitle(const std::string &title) override
Set the title of the object.
Definition: Generic3D.h:228
Gaudi::Generic3D::m_rep
std::unique_ptr< IMPLEMENTATION > m_rep
Reference to underlying implementation.
Definition: Generic3D.h:220
Gaudi::Axis::initialize
void initialize(TAxis *itaxi, bool)
Definition: Axis.h:71
template<class INTERFACE , class IMPLEMENTATION >

int Gaudi::Generic3D< INTERFACE, IMPLEMENTATION >::allEntries | ( |  | ) | const
| override

Get the number or all the entries, both in range and underflow/overflow bins of the IProfile.

Definition at line 249 of file Generic3D.h.

249 {
250 return int(m_rep->GetEntries());
251 }
Gaudi::Generic3D::m_rep
std::unique_ptr< IMPLEMENTATION > m_rep
Reference to underlying implementation.
Definition: Generic3D.h:220
template<typename INTERFACE, typename IMPLEMENTATION>

AIDA::IAnnotation& Gaudi::Generic3D< INTERFACE, IMPLEMENTATION >::annotation | ( |  | ) |
| inline override

Access annotation object.

Definition at line 61 of file Generic3D.h.

61 { return m_annotation; }
Gaudi::Generic3D::m_annotation
AIDA::Annotation m_annotation
Object annotations.
Definition: Generic3D.h:218
template<typename INTERFACE, typename IMPLEMENTATION>

const AIDA::IAnnotation& Gaudi::Generic3D< INTERFACE, IMPLEMENTATION >::annotation | ( |  | ) | const
| inline override

Access annotation object (cons)

Definition at line 63 of file Generic3D.h.

63 { return m_annotation; }
Gaudi::Generic3D::m_annotation
AIDA::Annotation m_annotation
Object annotations.
Definition: Generic3D.h:218
template<typename INTERFACE, typename IMPLEMENTATION>

int Gaudi::Generic3D< INTERFACE, IMPLEMENTATION >::binEntries | ( | int | indexX,
|  | int | indexY,
|  | int | indexZ
| ) |  | const
| inline override

Number of entries in the corresponding bin (ie the number of times fill was calle d for this bin).

Definition at line 94 of file Generic3D.h.

94 {
95 if (binHeight(indexX, indexY, indexZ)<=0) return 0;
96 double xx = binHeight(indexX, indexY, indexZ)/binError(indexX, indexY, indexZ);
97 return int(xx*xx+0.5);
98 }
Gaudi::Generic3D::binHeight
double binHeight(int indexX, int indexY, int indexZ) const
Total height of the corresponding bin (ie the sum of the weights in this bin).
Definition: Generic3D.h:127
Gaudi::Generic3D::binError
double binError(int indexX, int indexY, int indexZ) const override
The error of a given bin.
Definition: Generic3D.h:155
template<typename INTERFACE, typename IMPLEMENTATION>

int Gaudi::Generic3D< INTERFACE, IMPLEMENTATION >::binEntriesX | ( | int | index | ) | const
| inline override

Sum of all the entries of the bins along a given x bin.

Definition at line 100 of file Generic3D.h.

100 {
101 int n = 0;
102 for (int i = -2; i < yAxis().bins(); ++i)
103 for (int j = -2; j < zAxis().bins(); ++j)
104 n += binEntries(index,i,j);
105 return n;
106
107 }
GaudiPluginService.cpluginsvc.n
list n
Definition: cpluginsvc.py:217
Gaudi::Generic3D::zAxis
const AIDA::IAxis & zAxis() const override
Get the z axis of the IHistogram3D.
Definition: Generic3D.h:175
Gaudi::Generic3D::binEntries
int binEntries(int indexX, int indexY, int indexZ) const override
Number of entries in the corresponding bin (ie the number of times fill was calle d for this bin)...
Definition: Generic3D.h:94
ana.i
list i
Definition: ana.py:128
Gaudi::Generic3D::yAxis
const AIDA::IAxis & yAxis() const override
Get the y axis of the IHistogram3D.
Definition: Generic3D.h:173
template<typename INTERFACE, typename IMPLEMENTATION>

int Gaudi::Generic3D< INTERFACE, IMPLEMENTATION >::binEntriesY | ( | int | index | ) | const
| inline override

Sum of all the entries of the bins along a given y bin.

Definition at line 109 of file Generic3D.h.

109 {
110 int n = 0;
111 for (int i = -2; i < xAxis().bins(); ++i)
112 for (int j = -2; j < zAxis().bins(); ++j)
113 n += binEntries(i,index,j);
114 return n;
115 }
Gaudi::Generic3D::xAxis
const AIDA::IAxis & xAxis() const override
Get the x axis of the IHistogram3D.
Definition: Generic3D.h:171
GaudiPluginService.cpluginsvc.n
list n
Definition: cpluginsvc.py:217
Gaudi::Generic3D::zAxis
const AIDA::IAxis & zAxis() const override
Get the z axis of the IHistogram3D.
Definition: Generic3D.h:175
Gaudi::Generic3D::binEntries
int binEntries(int indexX, int indexY, int indexZ) const override
Number of entries in the corresponding bin (ie the number of times fill was calle d for this bin)...
Definition: Generic3D.h:94
ana.i
list i
Definition: ana.py:128
template<typename INTERFACE, typename IMPLEMENTATION>

int Gaudi::Generic3D< INTERFACE, IMPLEMENTATION >::binEntriesZ | ( | int | index | ) | const
| inline override

Sum of all the entries of the bins along a given z bin.

Definition at line 118 of file Generic3D.h.

118 {
119 int n = 0;
120 for (int i = -2; i < xAxis().bins(); ++i)
121 for (int j = -2; j < yAxis().bins(); ++j)
122 n += binEntries(i,j,index);
123 return n;
124 }
Gaudi::Generic3D::xAxis
const AIDA::IAxis & xAxis() const override
Get the x axis of the IHistogram3D.
Definition: Generic3D.h:171
GaudiPluginService.cpluginsvc.n
list n
Definition: cpluginsvc.py:217
Gaudi::Generic3D::binEntries
int binEntries(int indexX, int indexY, int indexZ) const override
Number of entries in the corresponding bin (ie the number of times fill was calle d for this bin)...
Definition: Generic3D.h:94
ana.i
list i
Definition: ana.py:128
Gaudi::Generic3D::yAxis
const AIDA::IAxis & yAxis() const override
Get the y axis of the IHistogram3D.
Definition: Generic3D.h:173
template<typename INTERFACE, typename IMPLEMENTATION>

double Gaudi::Generic3D< INTERFACE, IMPLEMENTATION >::binError | ( | int | indexX,
|  | int | indexY,
|  | int | indexZ
| ) |  | const
| inline override

The error of a given bin.

Definition at line 155 of file Generic3D.h.

156 { return m_rep->GetBinError ( rIndexX(indexX), rIndexY(indexY ), rIndexZ(indexZ ) ); }
Gaudi::Generic3D::rIndexZ
int rIndexZ(int index) const
Definition: Generic3D.h:82
Gaudi::Generic3D::rIndexX
int rIndexX(int index) const
Definition: Generic3D.h:80
Gaudi::Generic3D::rIndexY
int rIndexY(int index) const
Definition: Generic3D.h:81
Gaudi::Generic3D::m_rep
std::unique_ptr< IMPLEMENTATION > m_rep
Reference to underlying implementation.
Definition: Generic3D.h:220
template<typename INTERFACE, typename IMPLEMENTATION>

double Gaudi::Generic3D< INTERFACE, IMPLEMENTATION >::binHeight | ( | int | indexX,
|  | int | indexY,
|  | int | indexZ
| ) |  | const
| inline

Total height of the corresponding bin (ie the sum of the weights in this bin).

Definition at line 127 of file Generic3D.h.

128 { return m_rep->GetBinContent ( rIndexX(indexX), rIndexY(indexY), rIndexZ(indexZ) ); }
Gaudi::Generic3D::rIndexZ
int rIndexZ(int index) const
Definition: Generic3D.h:82
Gaudi::Generic3D::rIndexX
int rIndexX(int index) const
Definition: Generic3D.h:80
Gaudi::Generic3D::rIndexY
int rIndexY(int index) const
Definition: Generic3D.h:81
Gaudi::Generic3D::m_rep
std::unique_ptr< IMPLEMENTATION > m_rep
Reference to underlying implementation.
Definition: Generic3D.h:220
template<typename INTERFACE, typename IMPLEMENTATION>

double Gaudi::Generic3D< INTERFACE, IMPLEMENTATION >::binHeightX | ( | int | index | ) | const
| inline override

Sum of all the heights of the bins along a given x bin.

Definition at line 131 of file Generic3D.h.

131 {
132 double s = 0;
133 for (int i = -2; i < yAxis().bins(); ++i)
134 for (int j = -2; j < zAxis().bins(); ++j)
135 s += binHeight(index,i,j);
136 return s;
137 }
Gaudi::Generic3D::zAxis
const AIDA::IAxis & zAxis() const override
Get the z axis of the IHistogram3D.
Definition: Generic3D.h:175
Gaudi::Generic3D::binHeight
double binHeight(int indexX, int indexY, int indexZ) const
Total height of the corresponding bin (ie the sum of the weights in this bin).
Definition: Generic3D.h:127
gaudirun.s
string s
Definition: gaudirun.py:245
ana.i
list i
Definition: ana.py:128
Gaudi::Generic3D::yAxis
const AIDA::IAxis & yAxis() const override
Get the y axis of the IHistogram3D.
Definition: Generic3D.h:173
template<typename INTERFACE, typename IMPLEMENTATION>

double Gaudi::Generic3D< INTERFACE, IMPLEMENTATION >::binHeightY | ( | int | index | ) | const
| inline override

Sum of all the heights of the bins along a given y bin.

Definition at line 139 of file Generic3D.h.

139 {
140 double s = 0;
141 for (int i = -2; i < xAxis().bins(); ++i)
142 for (int j = -2; j < zAxis().bins(); ++j)
143 s += binHeight(i,index,j);
144 return s;
145 }
Gaudi::Generic3D::xAxis
const AIDA::IAxis & xAxis() const override
Get the x axis of the IHistogram3D.
Definition: Generic3D.h:171
Gaudi::Generic3D::zAxis
const AIDA::IAxis & zAxis() const override
Get the z axis of the IHistogram3D.
Definition: Generic3D.h:175
Gaudi::Generic3D::binHeight
double binHeight(int indexX, int indexY, int indexZ) const
Total height of the corresponding bin (ie the sum of the weights in this bin).
Definition: Generic3D.h:127
gaudirun.s
string s
Definition: gaudirun.py:245
ana.i
list i
Definition: ana.py:128
template<typename INTERFACE, typename IMPLEMENTATION>

double Gaudi::Generic3D< INTERFACE, IMPLEMENTATION >::binHeightZ | ( | int | index | ) | const
| inline override

Sum of all the heights of the bins along a given z bin.

Definition at line 147 of file Generic3D.h.

147 {
148 double s = 0;
149 for (int i = -2; i < xAxis().bins(); ++i)
150 for (int j = -2; j < yAxis().bins(); ++j)
151 s += binHeight(i,j,index);
152 return s;
153 }
Gaudi::Generic3D::xAxis
const AIDA::IAxis & xAxis() const override
Get the x axis of the IHistogram3D.
Definition: Generic3D.h:171
Gaudi::Generic3D::binHeight
double binHeight(int indexX, int indexY, int indexZ) const
Total height of the corresponding bin (ie the sum of the weights in this bin).
Definition: Generic3D.h:127
gaudirun.s
string s
Definition: gaudirun.py:245
ana.i
list i
Definition: ana.py:128
Gaudi::Generic3D::yAxis
const AIDA::IAxis & yAxis() const override
Get the y axis of the IHistogram3D.
Definition: Generic3D.h:173
template<typename INTERFACE, typename IMPLEMENTATION>

double Gaudi::Generic3D< INTERFACE, IMPLEMENTATION >::binMeanX | ( | int | indexX,
|  | int | ,
|  | int |
| ) |  | const
| inline override

The weighted mean along the x axis of a given bin.

Definition at line 85 of file Generic3D.h.

86 { return m_rep->GetXaxis()->GetBinCenter( rIndexX(indexX) ); }
Gaudi::Generic3D::rIndexX
int rIndexX(int index) const
Definition: Generic3D.h:80
Gaudi::Generic3D::m_rep
std::unique_ptr< IMPLEMENTATION > m_rep
Reference to underlying implementation.
Definition: Generic3D.h:220
template<typename INTERFACE, typename IMPLEMENTATION>

double Gaudi::Generic3D< INTERFACE, IMPLEMENTATION >::binMeanY | ( | int | ,
|  | int | indexY,
|  | int |
| ) |  | const
| inline override

The weighted mean along the y axis of a given bin.

Definition at line 88 of file Generic3D.h.

89 { return m_rep->GetYaxis()->GetBinCenter( rIndexY(indexY) ); }
Gaudi::Generic3D::rIndexY
int rIndexY(int index) const
Definition: Generic3D.h:81
Gaudi::Generic3D::m_rep
std::unique_ptr< IMPLEMENTATION > m_rep
Reference to underlying implementation.
Definition: Generic3D.h:220
template<typename INTERFACE, typename IMPLEMENTATION>

double Gaudi::Generic3D< INTERFACE, IMPLEMENTATION >::binMeanZ | ( | int | ,
|  | int | ,
|  | int | indexZ
| ) |  | const
| inline override

The weighted mean along the z axis of a given bin.

Definition at line 91 of file Generic3D.h.

92 { return m_rep->GetYaxis()->GetBinCenter( rIndexY(indexZ) ); }
Gaudi::Generic3D::rIndexY
int rIndexY(int index) const
Definition: Generic3D.h:81
Gaudi::Generic3D::m_rep
std::unique_ptr< IMPLEMENTATION > m_rep
Reference to underlying implementation.
Definition: Generic3D.h:220
template<typename INTERFACE, typename IMPLEMENTATION>

int Gaudi::Generic3D< INTERFACE, IMPLEMENTATION >::coordToIndexX | ( | double | coord | ) | const
| inline override

Get the bin number corresponding to a given coordinate along the x axis.

Definition at line 177 of file Generic3D.h.

177 { return xAxis().coordToIndex(coord);}
Gaudi::Generic3D::xAxis
const AIDA::IAxis & xAxis() const override
Get the x axis of the IHistogram3D.
Definition: Generic3D.h:171
template<typename INTERFACE, typename IMPLEMENTATION>

int Gaudi::Generic3D< INTERFACE, IMPLEMENTATION >::coordToIndexY | ( | double | coord | ) | const
| inline override

Get the bin number corresponding to a given coordinate along the y axis.

Definition at line 179 of file Generic3D.h.

179 { return yAxis().coordToIndex(coord);}
Gaudi::Generic3D::yAxis
const AIDA::IAxis & yAxis() const override
Get the y axis of the IHistogram3D.
Definition: Generic3D.h:173
template<typename INTERFACE, typename IMPLEMENTATION>

int Gaudi::Generic3D< INTERFACE, IMPLEMENTATION >::coordToIndexZ | ( | double | coord | ) | const
| inline override

Get the bin number corresponding to a given coordinate along the z axis.

Definition at line 181 of file Generic3D.h.

181 { return zAxis().coordToIndex(coord);}
Gaudi::Generic3D::zAxis
const AIDA::IAxis & zAxis() const override
Get the z axis of the IHistogram3D.
Definition: Generic3D.h:175
template<typename INTERFACE, typename IMPLEMENTATION>

int Gaudi::Generic3D< INTERFACE, IMPLEMENTATION >::dimension | ( |  | ) | const
| inline override

Get the Histogram's dimension.

Definition at line 51 of file Generic3D.h.

51 { return 3; }
template<class INTERFACE , class IMPLEMENTATION >

int Gaudi::Generic3D< INTERFACE, IMPLEMENTATION >::entries | ( |  | ) | const
| override

Get the number or all the entries.

Definition at line 244 of file Generic3D.h.

244 {
245 return m_rep->GetEntries();
246 }
Gaudi::Generic3D::m_rep
std::unique_ptr< IMPLEMENTATION > m_rep
Reference to underlying implementation.
Definition: Generic3D.h:220
template<class INTERFACE , class IMPLEMENTATION >

double Gaudi::Generic3D< INTERFACE, IMPLEMENTATION >::equivalentBinEntries | ( |  | ) | const
| override

Number of equivalent entries, i.e. `SUM[ weight ] ^ 2 / SUM[ weight^2 ]`

Definition at line 274 of file Generic3D.h.

274 {
275 if (sumBinHeights() <= 0) return 0;
276 Stat_t stats[11]; // cover up to 3D...
277 m_rep->GetStats(stats);
278 return stats[0]*stats[0]/stats[1];
279 }
Gaudi::Generic3D::sumBinHeights
double sumBinHeights() const override
Get the sum of in range bin heights in the IProfile.
Definition: Generic3D.h:264
Gaudi::Generic3D::m_rep
std::unique_ptr< IMPLEMENTATION > m_rep
Reference to underlying implementation.
Definition: Generic3D.h:220
template<typename INTERFACE, typename IMPLEMENTATION>

int Gaudi::Generic3D< INTERFACE, IMPLEMENTATION >::extraEntries | ( |  | ) | const
| inline override

Definition at line 196 of file Generic3D.h.

196 {
197 return
198 binEntries(AIDA::IAxis::UNDERFLOW_BIN,AIDA::IAxis::UNDERFLOW_BIN,AIDA::IAxis::UNDERFLOW_BIN) +
199 binEntries(AIDA::IAxis::UNDERFLOW_BIN,AIDA::IAxis::UNDERFLOW_BIN,AIDA::IAxis::OVERFLOW_BIN) +
200 binEntries(AIDA::IAxis::UNDERFLOW_BIN, AIDA::IAxis::OVERFLOW_BIN,AIDA::IAxis::UNDERFLOW_BIN) +
201 binEntries(AIDA::IAxis::OVERFLOW_BIN,AIDA::IAxis::UNDERFLOW_BIN,AIDA::IAxis::UNDERFLOW_BIN) +
202 binEntries(AIDA::IAxis::OVERFLOW_BIN,AIDA::IAxis::UNDERFLOW_BIN,AIDA::IAxis::OVERFLOW_BIN) +
203 binEntries(AIDA::IAxis::OVERFLOW_BIN,AIDA::IAxis::OVERFLOW_BIN,AIDA::IAxis::UNDERFLOW_BIN) +
204 binEntries(AIDA::IAxis::OVERFLOW_BIN, AIDA::IAxis::OVERFLOW_BIN,AIDA::IAxis::OVERFLOW_BIN);
205 }
Gaudi::Generic3D::binEntries
int binEntries(int indexX, int indexY, int indexZ) const override
Number of entries in the corresponding bin (ie the number of times fill was calle d for this bin)...
Definition: Generic3D.h:94
template<class INTERFACE , class IMPLEMENTATION >

double Gaudi::Generic3D< INTERFACE, IMPLEMENTATION >::maxBinHeight | ( |  | ) | const
| override

Get the maximum height of the in-range bins.

Definition at line 259 of file Generic3D.h.

259 {
260 return m_rep->GetMaximum();
261 }
Gaudi::Generic3D::m_rep
std::unique_ptr< IMPLEMENTATION > m_rep
Reference to underlying implementation.
Definition: Generic3D.h:220
template<typename INTERFACE, typename IMPLEMENTATION>

double Gaudi::Generic3D< INTERFACE, IMPLEMENTATION >::meanX | ( |  | ) | const
| inline override

The mean of the IHistogram3D along the x axis.

Definition at line 158 of file Generic3D.h.

158 { return m_rep->GetMean ( 1); }
Gaudi::Generic3D::m_rep
std::unique_ptr< IMPLEMENTATION > m_rep
Reference to underlying implementation.
Definition: Generic3D.h:220
template<typename INTERFACE, typename IMPLEMENTATION>

double Gaudi::Generic3D< INTERFACE, IMPLEMENTATION >::meanY | ( |  | ) | const
| inline override

The mean of the IHistogram3D along the y axis.

Definition at line 161 of file Generic3D.h.

161 { return m_rep->GetMean ( 2 ); }
Gaudi::Generic3D::m_rep
std::unique_ptr< IMPLEMENTATION > m_rep
Reference to underlying implementation.
Definition: Generic3D.h:220
template<typename INTERFACE, typename IMPLEMENTATION>

double Gaudi::Generic3D< INTERFACE, IMPLEMENTATION >::meanZ | ( |  | ) | const
| inline override

The mean of the IHistogram3D along the z axis.

Definition at line 163 of file Generic3D.h.

163 { return m_rep->GetMean ( 3 ); }
Gaudi::Generic3D::m_rep
std::unique_ptr< IMPLEMENTATION > m_rep
Reference to underlying implementation.
Definition: Generic3D.h:220
template<class INTERFACE , class IMPLEMENTATION >

double Gaudi::Generic3D< INTERFACE, IMPLEMENTATION >::minBinHeight | ( |  | ) | const
| override

Get the minimum height of the in-range bins.

Definition at line 254 of file Generic3D.h.

254 {
255 return m_rep->GetMinimum();
256 }
Gaudi::Generic3D::m_rep
std::unique_ptr< IMPLEMENTATION > m_rep
Reference to underlying implementation.
Definition: Generic3D.h:220
template<typename INTERFACE, typename IMPLEMENTATION>

std::string Gaudi::Generic3D< INTERFACE, IMPLEMENTATION >::name | ( |  | ) | const
| inline

object name

Definition at line 57 of file Generic3D.h.

57 { return m_annotation.value("Name"); }
Gaudi::Generic3D::m_annotation
AIDA::Annotation m_annotation
Object annotations.
Definition: Generic3D.h:218
AIDA::Annotation::value
std::string value(const std::string &key) const override
Retrieve the value for a given key.
Definition: Annotation.h:114
template<class INTERFACE , class IMPLEMENTATION >

std::ostream & Gaudi::Generic3D< INTERFACE, IMPLEMENTATION >::print | ( | std::ostream & | s | ) | const
| override virtual

Print (ASCII) the histogram into the output stream.

bin contents and errors are printed for all bins including under and overflows

Implements Gaudi::HistogramBase.

Definition at line 288 of file Generic3D.h.

289 {
291 m_rep->Print("all");
292 return s;
293 }
Gaudi::Generic3D::m_rep
std::unique_ptr< IMPLEMENTATION > m_rep
Reference to underlying implementation.
Definition: Generic3D.h:220
gaudirun.s
string s
Definition: gaudirun.py:245
template<typename INTERFACE, typename IMPLEMENTATION>

TObject* Gaudi::Generic3D< INTERFACE, IMPLEMENTATION >::representation | ( |  | ) | const
| inline override virtual

ROOT object implementation.

Implements Gaudi::HistogramBase.

Definition at line 46 of file Generic3D.h.

46 { return m_rep.get(); }
Gaudi::Generic3D::m_rep
std::unique_ptr< IMPLEMENTATION > m_rep
Reference to underlying implementation.
Definition: Generic3D.h:220
std::unique_ptr::get
T get(T...args)
template<typename INTERFACE, typename IMPLEMENTATION>

int Gaudi::Generic3D< INTERFACE, IMPLEMENTATION >::rIndexX | ( | int | index | ) | const
| inline

Definition at line 80 of file Generic3D.h.

80 { return m_xAxis.rIndex(index);}
Gaudi::Generic3D::m_xAxis
Gaudi::Axis m_xAxis
Definition: Generic3D.h:214
Gaudi::Axis::rIndex
int rIndex(int index) const
Convert a AIDA bin number on the axis to the ROOT bin number.
Definition: Axis.h:55
template<typename INTERFACE, typename IMPLEMENTATION>

int Gaudi::Generic3D< INTERFACE, IMPLEMENTATION >::rIndexY | ( | int | index | ) | const
| inline

Definition at line 81 of file Generic3D.h.

81 { return m_yAxis.rIndex(index);}
Gaudi::Generic3D::m_yAxis
Gaudi::Axis m_yAxis
Definition: Generic3D.h:215
Gaudi::Axis::rIndex
int rIndex(int index) const
Convert a AIDA bin number on the axis to the ROOT bin number.
Definition: Axis.h:55
template<typename INTERFACE, typename IMPLEMENTATION>

int Gaudi::Generic3D< INTERFACE, IMPLEMENTATION >::rIndexZ | ( | int | index | ) | const
| inline

Definition at line 82 of file Generic3D.h.

82 { return m_zAxis.rIndex(index);}
Gaudi::Generic3D::m_zAxis
Gaudi::Axis m_zAxis
Definition: Generic3D.h:216
Gaudi::Axis::rIndex
int rIndex(int index) const
Convert a AIDA bin number on the axis to the ROOT bin number.
Definition: Axis.h:55
template<typename INTERFACE, typename IMPLEMENTATION>

double Gaudi::Generic3D< INTERFACE, IMPLEMENTATION >::rmsX | ( |  | ) | const
| inline override

The RMS of the IHistogram3D along the x axis.

Definition at line 165 of file Generic3D.h.

165 { return m_rep->GetRMS( 1 ); }
Gaudi::Generic3D::m_rep
std::unique_ptr< IMPLEMENTATION > m_rep
Reference to underlying implementation.
Definition: Generic3D.h:220
template<typename INTERFACE, typename IMPLEMENTATION>

double Gaudi::Generic3D< INTERFACE, IMPLEMENTATION >::rmsY | ( |  | ) | const
| inline override

The RMS of the IHistogram3D along the y axis.

Definition at line 167 of file Generic3D.h.

167 { return m_rep->GetRMS( 2 ); }
Gaudi::Generic3D::m_rep
std::unique_ptr< IMPLEMENTATION > m_rep
Reference to underlying implementation.
Definition: Generic3D.h:220
template<typename INTERFACE, typename IMPLEMENTATION>

double Gaudi::Generic3D< INTERFACE, IMPLEMENTATION >::rmsZ | ( |  | ) | const
| inline override

The RMS of the IHistogram3D along the z axis.

Definition at line 169 of file Generic3D.h.

169 { return m_rep->GetRMS( 3 ); }
Gaudi::Generic3D::m_rep
std::unique_ptr< IMPLEMENTATION > m_rep
Reference to underlying implementation.
Definition: Generic3D.h:220
template<class INTERFACE , class IMPLEMENTATION >

bool Gaudi::Generic3D< INTERFACE, IMPLEMENTATION >::scale | ( | double | scaleFactor | ) |
| override

Scale the weights and the errors of all the IHistogram's bins (in-range and out-of-range ones) by a given scale factor.

Definition at line 282 of file Generic3D.h.

282 {
283 m_rep->Scale ( scaleFactor );
284 return true;
285 }
Gaudi::Generic3D::m_rep
std::unique_ptr< IMPLEMENTATION > m_rep
Reference to underlying implementation.
Definition: Generic3D.h:220
template<class INTERFACE , class IMPLEMENTATION >

bool Gaudi::Generic3D< INTERFACE, IMPLEMENTATION >::setName | ( | const std::string & | newName | ) |

Sets the name of the object.

Definition at line 238 of file Generic3D.h.

238 {
239 m_rep->SetName(newName.c_str());
240 m_annotation.setValue( "Name", newName );
241 return true;
242 }
AIDA::Annotation::setValue
void setValue(const std::string &key, const std::string &value) override
Set value for a given key.
Definition: Annotation.h:121
Gaudi::Generic3D::m_rep
std::unique_ptr< IMPLEMENTATION > m_rep
Reference to underlying implementation.
Definition: Generic3D.h:220
Gaudi::Generic3D::m_annotation
AIDA::Annotation m_annotation
Object annotations.
Definition: Generic3D.h:218
std::string::c_str
T c_str(T...args)
template<class INTERFACE , class IMPLEMENTATION >

bool Gaudi::Generic3D< INTERFACE, IMPLEMENTATION >::setTitle | ( | const std::string & | title | ) |
| override

Set the title of the object.

Definition at line 228 of file Generic3D.h.

228 {
229 m_rep->SetTitle(title.c_str());
230 if ( !annotation().addItem( "Title", title ) )
231 m_annotation.setValue( "Title" , title );
232 if ( !annotation().addItem( "title", title ) )
233 annotation().setValue( "title", title );
234 return true;
235 }
Gaudi::Generic3D::annotation
AIDA::IAnnotation & annotation() override
Access annotation object.
Definition: Generic3D.h:61
AIDA::Annotation::setValue
void setValue(const std::string &key, const std::string &value) override
Set value for a given key.
Definition: Annotation.h:121
Gaudi::Generic3D::m_rep
std::unique_ptr< IMPLEMENTATION > m_rep
Reference to underlying implementation.
Definition: Generic3D.h:220
Gaudi::Generic3D::m_annotation
AIDA::Annotation m_annotation
Object annotations.
Definition: Generic3D.h:218
std::string::c_str
T c_str(T...args)
template<class INTERFACE , class IMPLEMENTATION >

double Gaudi::Generic3D< INTERFACE, IMPLEMENTATION >::sumAllBinHeights | ( |  | ) | const
| override

Get the sum of all the bins heights (including underflow and overflow bin).

Definition at line 269 of file Generic3D.h.

269 {
270 return m_rep->GetSum();
271 }
Gaudi::Generic3D::m_rep
std::unique_ptr< IMPLEMENTATION > m_rep
Reference to underlying implementation.
Definition: Generic3D.h:220
template<class INTERFACE , class IMPLEMENTATION >

double Gaudi::Generic3D< INTERFACE, IMPLEMENTATION >::sumBinHeights | ( |  | ) | const
| override

Get the sum of in range bin heights in the IProfile.

Definition at line 264 of file Generic3D.h.

264 {
265 return m_rep->GetSumOfWeights();
266 }
Gaudi::Generic3D::m_rep
std::unique_ptr< IMPLEMENTATION > m_rep
Reference to underlying implementation.
Definition: Generic3D.h:220
template<typename INTERFACE, typename IMPLEMENTATION>

double Gaudi::Generic3D< INTERFACE, IMPLEMENTATION >::sumExtraBinHeights | ( |  | ) | const
| inline override

Get the sum of the underflow and overflow bin height.

Definition at line 74 of file Generic3D.h.

74 { return sumAllBinHeights()-sumBinHeights(); }
Gaudi::Generic3D::sumAllBinHeights
double sumAllBinHeights() const override
Get the sum of all the bins heights (including underflow and overflow bin).
Definition: Generic3D.h:269
Gaudi::Generic3D::sumBinHeights
double sumBinHeights() const override
Get the sum of in range bin heights in the IProfile.
Definition: Generic3D.h:264
template<typename INTERFACE, typename IMPLEMENTATION>

std::string Gaudi::Generic3D< INTERFACE, IMPLEMENTATION >::title | ( |  | ) | const
| inline override

Get the title of the object.

Definition at line 53 of file Generic3D.h.

53 { return m_annotation.value("Title");}
Gaudi::Generic3D::m_annotation
AIDA::Annotation m_annotation
Object annotations.
Definition: Generic3D.h:218
AIDA::Annotation::value
std::string value(const std::string &key) const override
Retrieve the value for a given key.
Definition: Annotation.h:114
template<class INTERFACE , class IMPLEMENTATION >

std::ostream & Gaudi::Generic3D< INTERFACE, IMPLEMENTATION >::write | ( | std::ostream & | s | ) | const
| override virtual

Write (ASCII) the histogram table into the output stream.

Implements Gaudi::HistogramBase.

Definition at line 298 of file Generic3D.h.

299 {
300 s << "\n3D Histogram Table: " << std::endl;
301 s << "BinX, BinY, BinZ, Height, Error " << std::endl;
302 for ( int i = 0; i < xAxis().bins(); ++i )
303 for ( int j = 0; j < yAxis().bins(); ++j )
304 for ( int k = 0; k < zAxis().bins(); ++k )
305 s << binMeanX( i, j, k ) << ", "
306 << binMeanY( i, j, k ) << ", "
307 << binMeanZ( i, j, k ) << ", "
308 << binHeight( i, j, k ) << ", "
309 << binError ( i, j, k ) << std::endl;
310 s << std::endl;
311 return s;
312 }
Gaudi::Generic3D::xAxis
const AIDA::IAxis & xAxis() const override
Get the x axis of the IHistogram3D.
Definition: Generic3D.h:171
std::endl
T endl(T...args)
Gaudi::Generic3D::binMeanY
double binMeanY(int, int indexY, int) const override
The weighted mean along the y axis of a given bin.
Definition: Generic3D.h:88
Gaudi::Generic3D::zAxis
const AIDA::IAxis & zAxis() const override
Get the z axis of the IHistogram3D.
Definition: Generic3D.h:175
Gaudi::Generic3D::binMeanX
double binMeanX(int indexX, int, int) const override
The weighted mean along the x axis of a given bin.
Definition: Generic3D.h:85
Gaudi::Generic3D::binMeanZ
double binMeanZ(int, int, int indexZ) const override
The weighted mean along the z axis of a given bin.
Definition: Generic3D.h:91
Gaudi::Generic3D::binHeight
double binHeight(int indexX, int indexY, int indexZ) const
Total height of the corresponding bin (ie the sum of the weights in this bin).
Definition: Generic3D.h:127
gaudirun.s
string s
Definition: gaudirun.py:245
Gaudi::Generic3D::binError
double binError(int indexX, int indexY, int indexZ) const override
The error of a given bin.
Definition: Generic3D.h:155
ana.i
list i
Definition: ana.py:128
Gaudi::Generic3D::yAxis
const AIDA::IAxis & yAxis() const override
Get the y axis of the IHistogram3D.
Definition: Generic3D.h:173
template<class INTERFACE , class IMPLEMENTATION >

int Gaudi::Generic3D< INTERFACE, IMPLEMENTATION >::write | ( | const char * | file_name | ) | const
| override virtual

Write (ASCII) the histogram table into a file.

Implements Gaudi::HistogramBase.

Definition at line 316 of file Generic3D.h.

317 {
318 TFile *f = TFile::Open(file_name,"RECREATE");
319 Int_t nbytes = m_rep->Write();
320 f->Close();
321 return nbytes;
322 }
Gaudi::Generic3D::m_rep
std::unique_ptr< IMPLEMENTATION > m_rep
Reference to underlying implementation.
Definition: Generic3D.h:220
template<typename INTERFACE, typename IMPLEMENTATION>

const AIDA::IAxis& Gaudi::Generic3D< INTERFACE, IMPLEMENTATION >::xAxis | ( |  | ) | const
| inline override

Get the x axis of the IHistogram3D.

Definition at line 171 of file Generic3D.h.

171 { return m_xAxis; }
Gaudi::Generic3D::m_xAxis
Gaudi::Axis m_xAxis
Definition: Generic3D.h:214
template<typename INTERFACE, typename IMPLEMENTATION>

const AIDA::IAxis& Gaudi::Generic3D< INTERFACE, IMPLEMENTATION >::yAxis | ( |  | ) | const
| inline override

Get the y axis of the IHistogram3D.

Definition at line 173 of file Generic3D.h.

173 { return m_yAxis; }
Gaudi::Generic3D::m_yAxis
Gaudi::Axis m_yAxis
Definition: Generic3D.h:215
template<typename INTERFACE, typename IMPLEMENTATION>

const AIDA::IAxis& Gaudi::Generic3D< INTERFACE, IMPLEMENTATION >::zAxis | ( |  | ) | const
| inline override

Get the z axis of the IHistogram3D.

Definition at line 175 of file Generic3D.h.

175 { return m_zAxis; }
Gaudi::Generic3D::m_zAxis
Gaudi::Axis m_zAxis
Definition: Generic3D.h:216

## Member Data Documentation

template<typename INTERFACE, typename IMPLEMENTATION>

AIDA::Annotation Gaudi::Generic3D< INTERFACE, IMPLEMENTATION >::m_annotation
| mutable protected

Object annotations.

Definition at line 218 of file Generic3D.h.

template<typename INTERFACE, typename IMPLEMENTATION>

std::string Gaudi::Generic3D< INTERFACE, IMPLEMENTATION >::m_classType
| protected

Definition at line 222 of file Generic3D.h.

template<typename INTERFACE, typename IMPLEMENTATION>

std::unique_ptr<IMPLEMENTATION> Gaudi::Generic3D< INTERFACE, IMPLEMENTATION >::m_rep
| protected

Reference to underlying implementation.

Definition at line 220 of file Generic3D.h.

template<typename INTERFACE, typename IMPLEMENTATION>

int Gaudi::Generic3D< INTERFACE, IMPLEMENTATION >::m_sumEntries = 0
| protected

Definition at line 224 of file Generic3D.h.

template<typename INTERFACE, typename IMPLEMENTATION>

Gaudi::Axis Gaudi::Generic3D< INTERFACE, IMPLEMENTATION >::m_xAxis
| protected

Definition at line 214 of file Generic3D.h.

template<typename INTERFACE, typename IMPLEMENTATION>

Gaudi::Axis Gaudi::Generic3D< INTERFACE, IMPLEMENTATION >::m_yAxis
| protected

Definition at line 215 of file Generic3D.h.

template<typename INTERFACE, typename IMPLEMENTATION>

Gaudi::Axis Gaudi::Generic3D< INTERFACE, IMPLEMENTATION >::m_zAxis
| protected

Definition at line 216 of file Generic3D.h.

The documentation for this class was generated from the following file:

- GaudiCommonSvc/src/HistogramSvc/Generic3D.h